//********************************************************************
//*** POSIX/sys/timeval.hh
//*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
//*** $Id: timeval.hh,v 1.5 2009-03-02 14:07:20 mws Exp $
//********************************************************************

#include <sys/time.h>
#include <iosfwd>

#ifndef FATALMIND_POSIX_TIMEVAL
#define FATALMIND_POSIX_TIMEVAL

namespace POSIX {
class timeval: public ::timeval
{
	public:
		timeval();
		~timeval();
	
		timeval& operator+=(const timeval&);
		timeval& operator-=(const timeval&);

		operator float() const;
		friend std::ostream& operator<<(std::ostream&, const timeval&);
		friend timeval operator-(const timeval&, const timeval&);
};

std::ostream& operator<<(std::ostream&, const timeval&);

}
#endif
