//********************************************************************
//*** ResourcePool/oracle/oracleStatement.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: oracleStatement.hh,v 1.7 2009-03-02 14:16:46 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_ORACLESTATEMENT_HH
#define RESOURCEPOOL_ORACLE_ORACLESTATEMENT_HH

#include <string>

namespace fatalmind {
namespace oracle {


// TODO: acutally this is a nop, oracle_bind should do this..
class oracleStatement {
	public:
		explicit oracleStatement(const std::string& SQL);
		const std::string& getSQL() const;
	private:
		std::string _oraSQL;
	friend
		bool operator<(const oracleStatement& lho, const oracleStatement& rho);
};

bool operator<(const oracleStatement& lho, const oracleStatement& rho);

} // namespace oracle
} // namespace fatalmind
#endif
