//********************************************************************
//*** ResourcePool/oracle/oracleType.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: oracleType.hh,v 1.18 2009-03-08 10:35:39 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_ORACLETYPE_HH
#define RESOURCEPOOL_ORACLE_ORACLETYPE_HH

#include <ostream>

#ifndef OCI_ORACLE
#include <oci.h>
#endif

namespace fatalmind {
namespace oracle {

class oracleType {
	public:
		oracleType(bool nul = true);
		
		virtual void* ptr() const = 0;
		virtual sb4   size() const = 0;
		virtual ub2   type() const = 0;
		virtual ~oracleType();
		virtual void outputoperator(std::ostream&) const = 0;

		dvoid* indptr() const;
		sb2  indicator() const;
		bool isnull() const;
		void setnull(bool nul = true);

	private:
		sb2 ind;
};

template<typename T>
class oracleTypeImpl: public oracleType {
	public:
		oracleTypeImpl(const T& val, bool nul = true);
		virtual ~oracleTypeImpl();
		
		virtual void* ptr() const;
		virtual sb4   size() const;
		virtual ub2   type() const;
		virtual void outputoperator(std::ostream&) const;
	private:
		T _val;
};

} // namespace oracle
} // namespace fatalmind
#endif
